import media from '@ohos.multimedia.media';
import fs from '@ohos.file.fs';

class FSAudioPlayer {
  private avPlayer: media.AVPlayer;

  private setAVPlayerCallback(): void {
    this.avPlayer.reset();
    this.avPlayer.on('stateChange', async (state) => {
      switch (state) {
        case 'idle':
          break;
        case 'initialized':
          this.avPlayer.prepare();
          break;
        case 'prepared':
          this.avPlayer.play();
          break;
        case 'playing':
          break;
        case 'completed':
          this.avPlayer.stop();
          break;
        case 'stopped':
          this.avPlayer.reset();
          break;
        case 'error':
          break;
        default:
          break;
      }
    });
  }

  async playAudio(path: string): Promise<void> {
    if (this.avPlayer) {
      await this.avPlayer.reset();
    } else {
      this.avPlayer = await media.createAVPlayer();
      this.setAVPlayerCallback();
    }
    let fdPath = 'fd://';
    let file = fs.openSync(path);
    fdPath = fdPath + '' + file.fd;
    this.avPlayer.url = fdPath;
  }
}

export default new FSAudioPlayer;
